package infopipes.examples;

import infopipes.pipes.BaseLogicalPipe;
import infopipes.pipes.PhysicalPipe;
import infopipes.utils.Polarity;
import infopipes.utils.PolarityConfig;

public class DuplicateLogicalPipe extends BaseLogicalPipe {
	static Polarity[] config0 = { Polarity.N, Polarity.P, Polarity.P };
	static Polarity[] config1 = { Polarity.P, Polarity.N, Polarity.P };
	static Polarity[] config2 = { Polarity.P, Polarity.P, Polarity.N };
	
	public DuplicateLogicalPipe() {
		inports.put("in", 0);
		outports.put("out0", 1);
		outports.put("out1", 2);
		configs.add(config0);
		configs.add(config1);
		configs.add(config2);
	}

	@Override
	public PhysicalPipe instantiate(PolarityConfig config) {
		if (config.equals(config0))
			return new DuplicatePhysicalPipeNPP();
		if (config.equals(config1))
			return new DuplicatePhysicalPipePNP();
		if (config.equals(config2))
			return new DuplicatePhysicalPipePPN();
		throw new RuntimeException();
	}
}
