package infopipes.examples;

import infopipes.pipes.BasePhysicalPipe;
import infopipes.pipes.LogicalPipe;
import infopipes.utils.Port;

public class DuplicatePhysicalPipeNPP extends BasePhysicalPipe {
	LogicalPipe logical;
	Port out0, out1;
	
	public DuplicatePhysicalPipeNPP() {
		logical = new DuplicateLogicalPipe();
	}

	public void connected() {
		final int out0Index = logical.outportIndex("out0");
		final int out1Index = logical.outportIndex("out1");
		
		if (!downstream.containsKey(out0Index))
			throw new RuntimeException();
		if (!downstream.containsKey(out1Index))
			throw new RuntimeException();
		out0 = downstream.get(out0Index);
		out1 = downstream.get(out1Index);
		logical = null;
	}

	@Override
	public void push(int index, Object packet) {
		if (index == 0) {
			out0.push(packet);
			out1.push(packet);
			return;
		}
		throw new RuntimeException();
	}
}
