package infopipes.examples;

import infopipes.pipes.BasePhysicalPipe;
import infopipes.pipes.LogicalPipe;
import infopipes.utils.Port;

public class DuplicatePhysicalPipePNP extends BasePhysicalPipe {
	LogicalPipe logical;
	Port in, out1;
	
	public DuplicatePhysicalPipePNP() {
		logical = new DuplicateLogicalPipe();
	}

	public void connected() {
		final int inIndex = logical.inportIndex("in");
		final int out1Index = logical.outportIndex("out1");
		
		if (!upstream.containsKey(inIndex))
			throw new RuntimeException();
		if (!downstream.containsKey(out1Index))
			throw new RuntimeException();
		in = upstream.get(inIndex);
		out1 = downstream.get(out1Index);
		logical = null;
	}

	@Override
	public Object pull(int index) {
		if (index == 1) {
			Object packet;
			packet = in.pull();
			out1.push(packet);
			return packet;
		}
		throw new RuntimeException();
	}
}
