package infopipes.pipes;

import infopipes.utils.PolarityChoice;
import infopipes.utils.PolarityConfig;
import infopipes.utils.PolaritySet;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public abstract class BaseLogicalPipe implements LogicalPipe {
	protected Map<String, Integer> inports;
	protected Map<String, Integer> outports;
	protected PolaritySet configs;

	public BaseLogicalPipe() {
		inports = new HashMap<String, Integer>();
		outports = new HashMap<String, Integer>();
		configs = new PolaritySet();
	}

	public Set<String> getInports() {
		return inports.keySet();
	}

	public Set<String> getOutports() {
		return outports.keySet();
	}

	public int inportIndex(String ident) {
		if (!inports.containsKey(ident))
			throw new RuntimeException();
		return inports.get(ident);
	}

	public int outportIndex(String ident) {
		if (!outports.containsKey(ident))
			throw new RuntimeException();
		return outports.get(ident);
	}

	public PolarityChoice validConfigurations() {
		return configs;
	}

	public abstract PhysicalPipe instantiate(PolarityConfig config);
}
