package infopipes.pipes;

import infopipes.utils.Port;
import infopipes.utils.PortMap;

public abstract class BasePhysicalPipe implements PhysicalPipe {
	protected PortMap upstream;
	protected PortMap downstream;
	
	public BasePhysicalPipe() {
		upstream = new PortMap();
		downstream = new PortMap();
	}

	public Port getPush(int index) {
		return new Port(this, index);
	}

	public Port getPull(int index) {
		return new Port(this, index);
	}

	public void linkPush(int index, Port dest) {
		downstream.put(index, dest);
	}

	public void linkPull(int index, Port src) {
		upstream.put(index, src);
	}
	
	public Object pull(int index) {
		throw new RuntimeException();
	}

	public void push(int index, Object packet) {
		throw new RuntimeException();
	}
}
