package infopipes.utils;

public class PipePort {
	public final String pipe;
	public final String ident;
	
	public PipePort(String pipe, String ident) {
		this.pipe = pipe;
		this.ident = ident;
	}

	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((ident == null) ? 0 : ident.hashCode());
		result = PRIME * result + ((pipe == null) ? 0 : pipe.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final PipePort other = (PipePort) obj;
		if (ident == null) {
			if (other.ident != null)
				return false;
		} else if (!ident.equals(other.ident))
			return false;
		if (pipe == null) {
			if (other.pipe != null)
				return false;
		} else if (!pipe.equals(other.pipe))
			return false;
		return true;
	}
}
