package infopipes.utils;

import java.util.HashSet;

public class PolaritySet extends HashSet<PolarityConfig> implements PolarityChoice {
	PolaritySet(PolaritySet set) {
		super(set);
	}
	
	public PolaritySet() {}

	public PolarityChoice copy() {
		return new PolaritySet(this);
	}
	
	public boolean add(Polarity[] p) {
		return add(new PolarityConfig(p));
	}
	
	public Polarity[] one() {
		return iterator().next().content;
	}

	public void constrainPolarity(int index, Polarity value) {
		PolaritySet filtered;
		
		filtered = new PolaritySet();
		for (PolarityConfig pc : this) {
			final Polarity[] c = pc.content;
			if (c[index].equals(value))
				filtered.add(c);
		}
		
		retainAll(filtered);
	}
	
	public Polarity testPolarity(int index) {
		Polarity agreement = Polarity.Unconstrained;
		
		for (PolarityConfig pc : this) {
			final Polarity[] c = pc.content;
			if (agreement.isUnconstrained())
				agreement = c[index];
			if (agreement != c[index])
				return Polarity.Unconstrained;
		}
		return agreement;
	}
}
